/**
 * In der Klasse <code>BodyEvent</code> werden alle Body Nachrichten analysiert,
 * interpretiert und im Weltmodell abgespeichert.
 *
 * @version <br>3.0 Copyright 2002 by Team 18<br><br>
 * @author
 * <ul>
 * <li><a href="mailto:heiner.litz@blauton.com">Heiner Litz</a></li>
 * </ul>
 * @since <br>JDK v 1.3.1<br><br>
 * @see <br> Weltmodell.java <br><br>
 */

import java.lang.*;
import java.util.*;

public class BodyEvent extends Event
{
    Weltmodell weltmodell;
    
    /**
     * Erstellt eine neue Instanz des Typs <code>BodyEvent</code> und verwendet einen Tokanizer,
     * um die bergebene Nachricht zu unterteilen und die relevanten Informationen zu extrahieren.
     * Diese werden interpretiert und in den Variablen des Weltmodells gespeichert.
     *
     * @param body Message
     * @param weltmodell
    */
    public BodyEvent(String message, Weltmodell weltmodell){
        this.weltmodell=weltmodell;

        StringTokenizer tokenizer = new StringTokenizer(message, "()");
        
        try{
            int zeit = Integer.parseInt(tokenizer.nextToken().substring(11).trim());
        }
        catch(Exception e){
            int zeit = 0;
        }
        
        //Zum Token mit den relevanten Daten wechseln
        tokenizer.nextToken();
        tokenizer.nextToken();

        String data=tokenizer.nextToken();
        //Die Stamina des Spielers wird ermittelt und im Weltmodell abgespeichert
        weltmodell.stamina = Double.parseDouble(data.substring(8, data.lastIndexOf(" ")));
    }
}

