/**
 * Die Klasse <code>ObjectPerception</code> verwaltet die gesehenen Objekte.
 * Diese haben eine Zeitmarke, einen Namen, einen Abstand,eine Richtung
 * und einen absoluten x und y Wert.
 *
 * @version <br>3.0 Copyright 2002 by Team 18<br><br>
 * @author
 * <ul>
 * <li><a href="mailto:florian_beier@web.de">Florian Beier</a></li>
 * </ul>
 * @since <br>JDK v 1.3.1<br><br>
 * @see <br> VisualEvent.java
 * @see Weltmodell.java  <br><br>
 */

public class ObjectPerception
{
    private int time;
    private String name;
    private double distance;
    private double direction;
    private double xAbs;
    private double yAbs;
    private double xAlt;
    private double yAlt;
    
    /**
     * Konstruktor von <code>ObjectPerception</code> fr die "ball, goal, line" Initialisierung
    */
    public ObjectPerception(){
        this.time = -1;
        this.name = "";
        this.distance = 0;
        this.direction = 0;
        this.xAbs = 0;
        this.yAbs = 0;
    }
    /**
     * Konstruktor von <code>ObjectPerception</code> fr die Flaggen Initialisierung
     *
     * @param name  Name des Objekts
     * @param xAbs  Absolute X-Position des Objekts
     * @param yAbs  Absolute Y-Position des Objekts
    */
    public ObjectPerception(String name, double xAbs, double yAbs){
        this.time = -1;
        this.name = name;
        this.distance = 100;
        this.direction = 0;
        this.xAbs = xAbs;
        this.yAbs = yAbs;
    }
    /**
     * Konstruktor von <code>ObjectPerception</code> fr die festen Objekte
     *
     * @param time  Zeitmarke des Objekts
     * @param name  Name des Objekts
     * @param distance  Abstand des Objekts
     * @param direction  Richtung des Objekts
    */
    public ObjectPerception(int time, String name, double distance, double direction){
        this.time = time;
        this.name = name;
        this.distance = distance;
        this.direction = direction;
        this.xAbs = 0;
        this.yAbs = 0;
    }
    /**
     * Konstruktor von <code>ObjectPerception</code> fr die variablen Objekte
     *
     * @param time  Zeitmarke des Objekts
     * @param name  Name des Objekts
     * @param distance  Abstand des Objekts
     * @param direction  Richtung des Objekts
     * @param xAbs  Absolute X-Position des Objekts
     * @param yAbs  Absolute Y-Position des Objekts
    */
    public ObjectPerception(int time, String name, double distance, double direction, double xAbs, double yAbs){
        this.time = time;
        this.name = name;
        this.distance = distance;
        this.direction = direction;
        this.xAbs = xAbs;
        this.yAbs = yAbs;
    }

    /**
     * Gibt den String <code>name</code> zurck.
     *
     * @return name  Name des Objekts
    */
    public String getName(){
        return name;
    }
   /**
     * Gibt den Integer <code>time</code> zurck.
     *
     * @return time  Zeitmarke des Objekts
    */
    public int getTime(){
        return time;
    }
    /**
     * Gibt die Double <code>distance</code> zurck.
     *
     * @return distance  Abstand des Objekts
    */
    public double getDistance(){
        return distance;
    }
    /**
     * Gibt die Double <code>direction</code> zurck.
     *
     * @return direction  Richtung des Objekts
    */
    public double getDirection(){
        return direction;
    }
    /**
     * Gibt die Double <code>xAbs</code> zurck.
     *
     * @return xAbs  Absolute X-Position des Objekts
    */
    public double getXAbs(){
        return xAbs;
    }
    /**
     * Gibt die Double <code>yAbs</code> zurck.
     *
     * @return yAbs  Absolute Y-Position des Objekts
    */
    public double getYAbs(){
        return yAbs;
    }
    /**
     * Gibt die Double <code>xAlt</code> zurck.
     *
     * @return xAlt  Alte X-Position des Objekts
    */
    public double getXAlt(){
        return xAlt;
    }
    /**
     * Gibt die Double <code>yAlt</code> zurck.
     *
     * @return yAlt  Alte Y-Position des Objekts
    */
    public double getYAlt(){
        return yAlt;
    }
    /**
     * Setzt den String <code>name</code>
     *
     * @param name  Name des Objekts
    */
    public void setName(String name){
        this.name=name;
    }
    /**
     * Setzt den Integer <code>time</code>
     *
     * @param time  Zeitmarke des Objekts
    */
    public void setTime(int time){
    this.time=time;
    }
    /**
     * Setzt die Double <code>distance</code>
     *
     * @param distance  Abstand des Objekts
    */
    public void setDistance(double distance){
        this.distance=distance;
    }
    /**
     * Setzt die Double <code>direction</code>
     *
     * @param direction  Richtung des Objekts
    */
    public void setDirection(double direction){
        this.direction=direction;
    }
    /**
     * Setzt die Double <code>xAbs</code>
     *
     * @param xAbs  Absolute X-Position des Objekts
    */
    public void setXAbs(double xAbs){
        xAlt=this.xAbs;
        this.xAbs=xAbs;
    }
    /**
     * Setzt die Double <code>yAbs</code>
     *
     * @param yAbs  Absolute Y-Position des Objekts
    */
    public void setYAbs(double yAbs){
        yAlt=this.yAbs;
        this.yAbs=yAbs;
    }
}
