/**
 * Die Klasse <code>Weltmodell</code> ist fr das Weltmodell des Spielers verantwortlich
 *
 * @version <br>3.0 Copyright 2002 by Team 18<br><br>
 * @author
 * <ul>
 * <li><a href="mailto:florian_beier@web.de">Florian Beier</a></li>
 * </ul>
 * @since <br>JDK v 1.3.1<br><br>
 * @see <br> Communication.java
 * @see ObjectPerception.java
 * @see Weltmodell.java <br><br>
 */

import java.util.*;

public class Weltmodell{

    //Jedes Weltmodell hat seinen eigenen Sensor
    public Sensor sensor;

    /**
     * Konstruktor von <code>Weltmodell</code>
     *
     * @param communication Kommunikation des Spielers
     */
    public Weltmodell(Communication communication){
        this.sensor = new Sensor(communication, this);
    }

    /**
     * Konstruktor fr die Graphik
     */
    public Weltmodell() {
    }

    //Ball initialisieren
    public ObjectPerception ball = new ObjectPerception();
    public ObjectPerception alterBall = new ObjectPerception();

    //Tore initialisieren
    public ObjectPerception goalL = new ObjectPerception("goalL", -52.5 , 0);
    public ObjectPerception goalR = new ObjectPerception("goalR", 52.5 , 0);

    //Linien initialisieren
    public ObjectPerception lineL = new ObjectPerception("lineL", 0, 0);
    public ObjectPerception lineR = new ObjectPerception("lineR", 0, 0);
    public ObjectPerception lineT = new ObjectPerception("lineT", 0, 0);
    public ObjectPerception lineB = new ObjectPerception("lineB", 0, 0);

    //Objekt Sollpos
    public ObjectPerception Sollpos = new ObjectPerception();

    //x und y Werte deklarieren
    public double xStart;
    public double yStart;
    public double xAktAbs;
    public double yAktAbs;

    //Teamname deklarieren
    public String teamname;

    //Wert fr Strke deklarieren
    public double stamina;

    //Zeit initialisieren
    public int time = -1;

    //Wert fr Seite initialisieren
    public int side = 2;

    //Wert fr die Anzahl der erhaltenen Seenachrichten initialisieren
    public int anzahlSeeNachrichten = 0;
    
    //Winkel initialisieren (mit einem Wert, den man erkennt)
    private double angle = 333;

    //Werte fr Send- und Seezeitpunkte initialisieren
    public boolean sendzeitpunkt = true;
    public boolean seezeitpunkt = false;
    public boolean seeball = false;

    //Mitteilungen des Schiedsrichters
    public boolean NormalPlay = false;
    public boolean opponentGoalieHasBall = false;  //Gegnerischer Torwart hat Ball aufgenommen
    public boolean ourGoalieHasBall = false;
    public boolean opponentGoal = false;  //Die Gegner haben ein Tor geschossen 50 cycles true
    public boolean ourGoal = false;
    public boolean opponentFreeKick = false;  //Die Gegner haben Freistoss
    public boolean ourFreeKick = false;
    public boolean opponentOffside = false;  //Die Gegner bekommen in 30 cycles Freistoss wegen Abseits
    public boolean ourOffside = false;
    public boolean opponentCornerKick = false;  //Die Gegner haben Eckball
    public boolean ourCornerKick = false;
    public boolean opponentKickIn = false;  //Die Gegner haben Einwurf
    public boolean ourKickIn = false;
    public boolean ourKickOff = false;
    public boolean opponentKickOff = false;
    public boolean opponentGoalKick = false;
    public boolean ourGoalKick = false;
    public boolean halfTime = false;
    public boolean beforeKickOff = false;

    //Flaggen initialisieren
    //Flaggen ganz oben
    public ObjectPerception f_t_l_50 = new ObjectPerception("f_t_l_50", -50,-39);
    public ObjectPerception f_t_l_40 = new ObjectPerception("f_t_l_40", -40,-39);
    public ObjectPerception f_t_l_30 = new ObjectPerception("f_t_l_30", -30,-39);
    public ObjectPerception f_t_l_20 = new ObjectPerception("f_t_l_20", -20,-39);
    public ObjectPerception f_t_l_10 = new ObjectPerception("f_t_l_10", -10,-39);
    public ObjectPerception f_t_0 = new ObjectPerception("f_t_0", 0,-39);
    public ObjectPerception f_t_r_10 = new ObjectPerception("f_t_r_10", 10,-39);
    public ObjectPerception f_t_r_20 = new ObjectPerception("f_t_r_20", 20,-39);
    public ObjectPerception f_t_r_30 = new ObjectPerception("f_t_r_30", 30,-39);
    public ObjectPerception f_t_r_40 = new ObjectPerception("f_t_r_40", 40,-39);
    public ObjectPerception f_t_r_50 = new ObjectPerception("f_t_r_50", 50,-39);

    //Flaggen ganz rechts
    public ObjectPerception f_r_t_30 = new ObjectPerception("f_r_t_30", 57.5,-30);
    public ObjectPerception f_r_t_20 = new ObjectPerception("f_r_t_20", 57.5,-20);
    public ObjectPerception f_r_t_10 = new ObjectPerception("f_r_t_10", 57.5,-10);
    public ObjectPerception f_r_0 = new ObjectPerception("f_r_0", 57.5,0);
    public ObjectPerception f_r_b_10 = new ObjectPerception("f_r_b_10", 57.5,10);
    public ObjectPerception f_r_b_20 = new ObjectPerception("f_r_b_20", 57.5,20);
    public ObjectPerception f_r_b_30 = new ObjectPerception("f_r_b_30", 57.5,30);

    //Flaggen ganz unten
    public ObjectPerception f_b_r_50 = new ObjectPerception("f_b_r_50", 50,39);
    public ObjectPerception f_b_r_40 = new ObjectPerception("f_b_r_40", 40,39);
    public ObjectPerception f_b_r_30 = new ObjectPerception("f_b_r_30", 30,39);
    public ObjectPerception f_b_r_20 = new ObjectPerception("f_b_r_20", 20,39);
    public ObjectPerception f_b_r_10 = new ObjectPerception("f_b_r_10", 10,39);
    public ObjectPerception f_b_0 = new ObjectPerception("f_b_0", 0,39);
    public ObjectPerception f_b_l_10 = new ObjectPerception("f_b_l_10", -10,39);
    public ObjectPerception f_b_l_20 = new ObjectPerception("f_b_l_20", -20,39);
    public ObjectPerception f_b_l_30 = new ObjectPerception("f_b_l_30", -30,39);
    public ObjectPerception f_b_l_40 = new ObjectPerception("f_b_l_40", -40,39);
    public ObjectPerception f_b_l_50 = new ObjectPerception("f_b_l_50", -50,39);

    //Flaggen ganz links
    public ObjectPerception f_l_b_30 = new ObjectPerception("f_l_b_30", -57.5,30);
    public ObjectPerception f_l_b_20 = new ObjectPerception("f_l_b_20", -57.5,20);
    public ObjectPerception f_l_b_10 = new ObjectPerception("f_l_b_10", -57.5,10);
    public ObjectPerception f_l_0 = new ObjectPerception("f_l_0", -57.5,0);
    public ObjectPerception f_l_t_10 = new ObjectPerception("f_l_t_10", -57.5,-10);
    public ObjectPerception f_l_t_20 = new ObjectPerception("f_l_t_20", -57.5,-20);
    public ObjectPerception f_l_t_30 = new ObjectPerception("f_l_t_30", -57.5,-30);

    //Eck- und Mittellinienflggen
    public ObjectPerception f_l_t = new ObjectPerception("f_l_t", -52.5,-34);
    public ObjectPerception f_c_t = new ObjectPerception("f_c_t", 0,-34);
    public ObjectPerception f_r_t = new ObjectPerception("f_r_t", 52.5,-34);
    public ObjectPerception f_r_b = new ObjectPerception("f_r_b", 52.5,34);
    public ObjectPerception f_c_b = new ObjectPerception("f_c_b", 0,34);
    public ObjectPerception f_l_b = new ObjectPerception("f_l_b", -52.5,34);

    //beim Tor links
    public ObjectPerception f_g_l_t = new ObjectPerception("f_g_l_t", -52.5,-7.01);
    public ObjectPerception f_g_l_b = new ObjectPerception("f_g_l_b", -52.5,7.01);
    public ObjectPerception f_p_l_t = new ObjectPerception("f_p_l_t", -36,-20);
    public ObjectPerception f_p_l_c = new ObjectPerception("f_p_l_c", -36,0);
    public ObjectPerception f_p_l_b = new ObjectPerception("f_p_l_b", -36,20);

    //beim Tor rechts
    public ObjectPerception f_g_r_t = new ObjectPerception("f_g_r_t", 52.5,-7.01);
    public ObjectPerception f_g_r_b = new ObjectPerception("f_g_r_b", 52.5,7.01);
    public ObjectPerception f_p_r_t = new ObjectPerception("f_p_r_t", 36,-20);
    public ObjectPerception f_p_r_c = new ObjectPerception("f_p_r_c", 36,0);
    public ObjectPerception f_p_r_b = new ObjectPerception("f_p_r_b", 36,20);

    //Mittelpunkt
    public ObjectPerception f_c = new ObjectPerception("f_c", 0,0);

    /**
    *
    * Setzt den Winkel
    *
    * @param angle Blickwinkel setzen
    */
    public void setAngle(double angle){ this.angle = angle; }

    /**
     * Gibt die Double <code>angle</code> zurck.
     *
     * @return Winkel aktueller Blickwinkel
     */
    public double getAngle() { return angle; }


    //Array fr die Flaggen
    public ObjectPerception[] flagArray = {f_t_l_50, f_t_l_40, f_t_l_30, f_t_l_20, f_t_l_10, f_t_0, f_t_r_10, f_t_r_20, f_t_r_30, f_t_r_40, f_t_r_50,
        f_r_t_30, f_r_t_20, f_r_t_10, f_r_0, f_r_b_10, f_r_b_20, f_r_b_30, f_b_r_50, f_b_r_40, f_b_r_30, f_b_r_20, f_b_r_10,
        f_b_0, f_b_l_10, f_b_l_20, f_b_l_30, f_b_l_40, f_b_l_50, f_l_b_30, f_l_b_20, f_l_b_10, f_l_0, f_l_t_10, f_l_t_20,
        f_l_t_30, f_l_t, f_c_t, f_r_t, f_r_b, f_c_b, f_l_b, f_g_l_t, f_g_l_b, f_p_l_t, f_p_l_c, f_p_l_b, f_g_r_t, f_g_r_b,
        f_p_r_t, f_p_r_c, f_p_r_b, f_c};

    //Vektoren fr die anderen Spieler
    public Vector mitspieler = new Vector(30);
    public Vector gegenspieler = new Vector(30);

    /**
    * Fgt einen Spieler an den Vektor an
    *
    * @param objectPerception anzufuegendes Objekt
    */
    public void addMitspieler(ObjectPerception objectPerception) {mitspieler.addElement(objectPerception);}

    /**
    * Fgt einen Spieler an den Vektor an
    *
    * @param objectPerception anzufuegendes Objekt
     */
    public void addGegenspieler(ObjectPerception objectPerception) {gegenspieler.addElement(objectPerception);}


}